#!BPY
# -*- coding: utf-8 -*-
"""
Name: 'Metasequoia (.mqo)...'
Blender: 245
Group: 'Import'
Tip: 'Import from Metasequoia file format (.mqo)'

"""

__author__ = "Nightcalm & kyk & ◆QPjDDYwQLI"
__url__ = "http://nightcalm.net"
__version__ = "2.12.1"
__bpydoc__='''\

MQO Importer

This script imports a mqo file and metarials into Blender.
MQO file reading required GANGu module.

Original script&module from http://luxla.net (Thanks! kyk).


2.11a
- GANGu module compile for Blender 2.45(&Python 2.5)
- Change script file name mqo.py to mqo_import.py
- Change Name
- Change author(Thanks kyk)
- Add bpydoc

'''

import GANGu,Blender
from Blender import BGL,Draw,Window
ganguini = Blender.Registry.GetKey("GANGu",1) or dict()
inikeys = ["Target","ColorMap","NormalMap","AlphaMap","Scale", "UseTargetDir", "DontGroup"]
gitems = [ Draw.Create(ganguini.setdefault( k,v)) for k, v in zip(inikeys,["","","","",0.1,0,0]) ]

def draw():
    global gitems, inikeys, ganguini
    BGL.glClearColor( 0, 0.3, 0.5 , 0. )
    BGL.glClear( BGL.GL_COLOR_BUFFER_BIT )
    BGL.glColor3f( 1.0, 1.0, 1.0 )
    Draw.PushButton("Import", 255, 40, 10, 100, 40)
    BGL.glRasterPos2f( 160, 35 )
    Draw.Text("GANGu MQO Importer")
    BGL.glRasterPos2f( 160, 15 )
    Draw.Text("Powered by Boost Library")

    toggle_button_texts = ["Map dir is Target dir", "Don't make a group"]
    for name, gitem, ev, posy in zip( inikeys, gitems, range(0,7), range(70,320,30) ):
        if ev<5:
            BGL.glRasterPos2f( 20, posy )
            Draw.Text( name )
            Draw.PushButton( str(gitem.val), ev, 100, posy, 200, 20)
        else:
            gitems[ev] = Draw.Toggle(toggle_button_texts[ev-5], ev, 100, posy, 200, 20, gitem.val, "")

def gevent(ev):
    global gitems, inikeys, ganguini

    def change_value( val ):
        if val: gitems[ev].val = val

    def save_ini():
        for inikey,gitem in zip(inikeys,gitems):
            ganguini[inikey] = gitem.val
        Blender.Registry.SetKey("GANGu",ganguini,True)

    if ev is 255:
        save_ini()
        GANGu.readmqo( ganguini["Target"] )
    elif ev in [0,1,2,3]:
        Blender.Window.FileSelector( change_value, inikeys[ev], ganguini[inikeys[ev]] )
    elif ev is 4:
        change_value( Draw.PupFloatInput("scale", ganguini["Scale"], 0.01, 1.0, 5, 3))
    elif ev in [5,6]:
        Draw.Redraw(1)

    Window.RedrawAll()

Draw.Register(draw, lambda e,v: e == Draw.ESCKEY and not v and Blender.Draw.Exit() , gevent)